/**
* Copyright 2011 Microsoft Corporation
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*   http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

(function(o,f){var b=o.Rx,l=b.Observable,p=l.prototype,e=b.AsyncSubject,i=l.create,m=l.createWithDisposable,n=Array.prototype.slice,b=f.fn;f.Deferred.prototype.toObservable=function(){var a=new e;this.done(function(){a.onNext(n.call(arguments));a.onCompleted()}).fail(function(){a.onError(n.call(arguments))});return a};p.toDeferred=function(){var a=f.Deferred();this.subscribe(function(d){a.resolve(d)},function(d){a.reject(d)});return a};f.Callbacks.prototype.toObservable=function(){var a=this;return i(function(d){var c=
function(a){d.onNext(a)};a.add(c);return function(){a.remove(c)}})};b.onAsObservable=function(a,d,c){var b=this;return i(function(h){var j=function(a){h.onNext(a)};b.on(a,d,c,j);return function(){b.off(a,d,j)}})};b.bindAsObservable=function(a,d){var c=this;return i(function(b){var h=function(a){b.onNext(a)};c.bind(a,d,h);return function(){c.unbind(a,h)}})};b.delegateAsObservable=function(a,d,c){var b=this;return i(function(h){var j=function(a){h.onNext(a)};b.delegate(a,d,c,j);return function(){b.undelegate(a,
d,j)}})};b.liveAsObservable=function(a,d){var b=this;return i(function(g){var h=function(a){g.onNext(a)};b.live(a,d,h);return function(){b.die(a,h)}})};b.changeAsObservable=function(a){return this.bindAsObservable("change",a)};b.clickAsObservable=function(a){return this.bindAsObservable("click",a)};b.dblclickAsObservable=function(a){return this.bindAsObservable("dblclick",a)};b.focusAsObservable=function(a){return this.bindAsObservable("focus",a)};b.focusinAsObservable=function(a){return this.bindAsObservable("focusin",
a)};b.focusoutAsObservable=function(a){return this.bindAsObservable("focusout",a)};b.keydownAsObservable=function(a){return this.bindAsObservable("keydown",a)};b.keyupAsObservable=function(a){return this.bindAsObservable("keyup",a)};b.loadAsObservable=function(a){return this.bindAsObservable("load",a)};b.mousedownAsObservable=function(a){return this.bindAsObservable("mousedown",a)};b.mouseenterAsObservable=function(a){return this.bindAsObservable("mouseenter",a)};b.mouseleaveAsObservable=function(a){return this.bindAsObservable("mouseleave",
a)};b.mousemoveAsObservable=function(a){return this.bindAsObservable("mousemove",a)};b.mouseoutAsObservable=function(a){return this.bindAsObservable("mouseout",a)};b.mouseoverAsObservable=function(a){return this.bindAsObservable("mouseover",a)};b.mouseupAsObservable=function(a){return this.bindAsObservable("mouseup",a)};b.resizeAsObservable=function(a){return this.bindAsObservable("resize",a)};b.scrollAsObservable=function(a){return this.bindAsObservable("scroll",a)};b.selectAsObservable=function(a){return this.bindAsObservable("select",
a)};b.submitAsObservable=function(a){return this.bindAsObservable("submit",a)};b.unloadAsObservable=function(a){return this.bindAsObservable("unload",a)};b.oneAsObservable=function(a,d,b){var g=this;return m(function(h){var e=function(f){g.off(a,d,b,e);h.onNext(f);h.onCompleted()};g.on(a,d,b,e);return dispoableEmpty})};b.readyAsObservable=function(){var a=this;return m(function(d){a.ready(function(a){d.onNext(a)});return dispoableEmpty})};b.hideAsObservable=function(a,d){var b=new e;this.hide(a,d,
function(){b.onNext(this);b.onCompleted()});return b};b.showAsObservable=function(a){var d=new e;this.show(a,function(){d.onNext(this);d.onCompleted()});return d};b.animateAsObservable=function(a,d,b){var g=new e;this.animate(a,d,b,function(){g.onNext(this);g.onCompleted()});return g};b.fadeInAsObservable=function(a,b){var c=new e;this.fadeIn(a,b,function(){c.onNext(this);c.onCompleted()});return c};b.fadeToAsObservable=function(a,b,c){var g=new e;this.fadeTo(a,b,c,function(){g.onNext(this);g.onCompleted()});
return g};b.fadeOutAsObservable=function(a,b){var c=new e;this.fadeOut(a,b,function(){c.onNext(this);c.onCompleted()});return c};b.fadeToggleAsObservable=function(a,b){var c=new e;this.fadeToggle(a,b,function(){c.onNext(this);c.onCompleted()});return c};b.slideDownAsObservable=function(a){var b=new e;this.slideDown(a,function(){b.onNext(this);b.onCompleted()});return b};b.slideUpAsObservable=function(a){var b=new e;this.slideUp(a,function(){b.onNext(this);b.onCompleted()});return b};b.slideToggleAsObservable=
function(a){var b=new e;this.slideToggle(a,function(){b.onNext(this);b.onCompleted()});return b};b.toggleAsObservable=function(a,b){var c=new e;this.toggle(a,b,function(){c.onNext(this);c.onCompleted()});return c};var k=f.ajaxAsObservable=function(a){var b=new e,c={success:function(a,c,e){b.onNext({data:a,textStatus:c,jqXHR:e});b.onCompleted()},error:function(a,c,e){b.onError({jqXHR:a,textStatus:c,errorThrown:e})}};f.extend(!0,c,a);f.ajax(c);return b};f.getAsObservable=function(a,b,c){return k({url:a,
dataType:c,data:b})};f.getJSONAsObservable=function(a,b){return k({url:a,dataType:"json",data:b})};f.getScriptAsObservable=function(a){return k({url:a,dataType:"script"})};f.postAsObservable=function(a,b,c){return k({url:a,dataType:c,data:b,type:"POST"})}})(this,jQuery);